import gobject
import dbus
import dbus.service
import dbus.glib


def debug(message):

    return
    print("Debug: %s" % message)


def log(message):

    print(message)


class DBusObject(dbus.service.Object):

    def __init__(self, app):
		
        self.app = app
        session_bus = dbus.SessionBus()
        bus_name = dbus.service.BusName("com.weej.SessionPresenceManager", bus=session_bus, do_not_queue=True)
        debug("DBusObject bus name obtained")
        dbus.service.Object.__init__(self, bus_name, "/com/weej/SessionPresenceManager")
        debug("DBusObject initialised")
        
    @dbus.service.method("com.weej.SessionPresenceManager")
    def GetStatus(self):

        status = self.app.get_status()
#        return status
        # Method signature is "(ass)". Make sure it is kept that way for the sake of our C/C++ clients!
        # Er, OK, we'll cheat with a v seeing as the DBUS GLIB BINDINGS SUCK!
     	response = dbus.Struct((dbus.Array(map(dbus.String, status[0])), dbus.String(status[1])), variant_level=1)
     	return response
     
    @dbus.service.method("com.weej.SessionPresenceManager")
    def SetStatus(self, status):
 		
        return self.app.set_status(status)
        
    @dbus.service.signal("com.weej.SessionPresenceManager")
    def StatusChanged(self, status):
    
        debug("Status changed signal emitted: %s" % repr(status))


class App:

    def __init__(self):
    
        self.dbus_object = DBusObject(self)

        initial_status = (("present",), "")
        self.set_status(initial_status)
        
    def get_status(self):
    
        return self._status

    def set_status(self, status):

        debug("Status set: %s" % repr(status))
        self._status = status
        self.dbus_object.StatusChanged(self.dbus_object.GetStatus())


app = App()

mainloop = gobject.MainLoop()
mainloop.run()
