import gobject
import dbus
import dbus.glib

class App:

    last_present_status = (("present",), "")

    def __init__(self):

        self.we_activated_ss = False
        session_bus = dbus.SessionBus()

        sso = session_bus.get_object("org.gnome.ScreenSaver", "/org/gnome/ScreenSaver")
        self.ssif = dbus.Interface(sso, "org.gnome.ScreenSaver")
        spmo = session_bus.get_object("com.weej.SessionPresenceManager", "/com/weej/SessionPresenceManager")
        self.spmif = dbus.Interface(spmo, "com.weej.SessionPresenceManager")

        self.ssif.connect_to_signal("ActiveChanged", self.on_ss_active_changed_cb)
        self.spmif.connect_to_signal("StatusChanged", self.on_status_changed_cb)

        self.update_status(self.spmif.GetStatus())

    def update_status(self, status):
        
        if (status[0][0:1] == ["present",]):
            self.last_present_status = status

        if (status[0][0:1] == ["absent",]):
            self.ssif.SetActive(True)
            self.we_activated_ss = True
        else:
            # Is this a security vulnerability?
            self.ssif.SetActive(False)

    def on_status_changed_cb(self, status):
    
        self.update_status(status)

    def on_ss_active_changed_cb(self, active):

        if (not active and self.we_activated_ss):
            self.we_activated_ss = False
            self.spmif.SetStatus(self.last_present_status)


app = App()

mainloop = gobject.MainLoop()
mainloop.run()
